/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */
package gaiacrtn.config;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

public class PropertiesApp {
   static private Properties _prpApp = new Properties();

   final static public String APP_NAME = "application.name";
   final static public String APP_VERSION = "application.version";
   final static public String APP_HOME = "application.home";

   static public void setPrp( String strKey,
                              String strValue ) {
      _prpApp.setProperty( strKey, strValue );
   }

   static public String getPrp( String strKey ) {
      return _prpApp.getProperty( strKey );
   }

   static public String getPrp( String strKey, String strDefaultValue ) {
      return _prpApp.getProperty( strKey, strDefaultValue );
   }

   static public boolean getBoolPrp( String strKey ) {
      return Boolean.valueOf( getPrp( strKey ) ).booleanValue();
   }

   static public boolean getBoolPrp( String strKey,
                                     boolean bDefaultValue ) {
      return Boolean.valueOf(
            getPrp( strKey, String.valueOf( bDefaultValue ) ) ).booleanValue();
   }

   static public int getIntPrp( String strKey ) {
      return Integer.valueOf( getPrp( strKey ) ).intValue();
   }

   static public int getIntPrp( String strKey, int nDefaultValue ) {
      return Integer.valueOf(
            getPrp( strKey, String.valueOf( nDefaultValue ) ) ).intValue();
   }

   static public void load() throws IOException {
      String strOldAppName = getPrp( APP_NAME );
      String strOldAppVersion = getPrp( APP_VERSION );
      String strOldAppHome = getPrp( APP_HOME );
      try {
         _prpApp.load( new FileInputStream( prpFilename() ) );
      } catch (IOException e) {
         throw e;
      } finally {
         setPrp( APP_NAME, strOldAppName );
         setPrp( APP_VERSION, strOldAppVersion );
         setPrp( APP_HOME, strOldAppHome );
      }
   }

   static public void save() throws IOException {
      String strOldAppHome = getPrp( APP_HOME );
      String strPrpFilename = prpFilename();
      String strPrpHeader = getPrp( APP_NAME ) + " " + getPrp( APP_VERSION );
      _prpApp.remove( APP_HOME );
      try {
         _prpApp.store( new FileOutputStream( strPrpFilename ), strPrpHeader );
      } catch (IOException e) {
         throw e;
      } finally {
         setPrp( APP_HOME, strOldAppHome );
      }
   }

   static public String appName() {
      return getPrp( APP_NAME );
   }

   static public String appVersion() {
      return getPrp( APP_VERSION );
   }

   static public String appHome() {
      return getPrp( APP_HOME );
   }

   static private String prpFilename() {
      return appHome() + File.separator + getPrp( APP_NAME ) + ".properties";
   }
}