package gaiacrtn.diffword.ui;

import gaiacrtn.diffword.ui.model.ModelFilename;
import gaiacrtn.diffword.ui.ModelString2TextFieldBinder;
import gaiacrtn.swing.text.DocumentHelper;

import javax.swing.*;
import javax.swing.text.Document;
import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;

public class DwPanelFileSelect extends JPanel {
   JTextField _textfieldFilename = new JTextField( 32 );
   JButton _buttonChoose = new JButton( "..." );
   ModelFilename _model;
   Color _colorForegroundDefault = _textfieldFilename.getForeground();

   public DwPanelFileSelect( ModelFilename model ) {
      _model = model;
      _textfieldFilename.setText( _model.text() );
      add( _textfieldFilename );
      add( _buttonChoose );

      setBorder( BorderFactory.createEtchedBorder() );


      _buttonChoose.addActionListener( new ActionListener() {
         public void actionPerformed( ActionEvent e ) {
            _model.chooseFilename();
         }
      } );

      ModelString2TextFieldBinder.bind( _textfieldFilename, _model );

      _textfieldFilename.getDocument().addDocumentListener(
            new DocumentListener() {
               public void changedUpdate( DocumentEvent e ) {
               }

               public void removeUpdate( DocumentEvent e ) {
                  checkFilename( e.getDocument() );
               }

               public void insertUpdate( DocumentEvent e ) {
                  checkFilename( e.getDocument() );
               }

               void checkFilename( Document doc ) {  // should be put in another thread
                  if ( new File( DocumentHelper.getText( doc ) ).exists() )
                     _textfieldFilename.setForeground( _colorForegroundDefault );
                  else
                     _textfieldFilename.setForeground( Color.red );
               }
            } );
   }
}
