package gaiacrtn.diffword.ui;

import gaiacrtn.swing.model.ModelString;

import javax.swing.*;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;

public class ModelString2TextFieldBinder {
   /** Binds a JTextField to a ModelString.
    * The textfield is updated when the ModelString is modified, and the
    * ModelString is updated when the JTextField lost focus.
    */
   static public void bind( final JTextField textfield,
                            final ModelString model ) {
      textfield.addFocusListener( new FocusAdapter() {
         public void focusLost( FocusEvent e ) {
            model.setText( textfield.getText() );
         }
      } );
      model.addChangeListener( new ChangeListener() {
         public void stateChanged( ChangeEvent e ) {
            textfield.setText( model.text() );
         }
      } );
   }
}
