/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */
/* Change:
 * - changed menu label from name_label to name_menu for homogeneity with cmd.
 */

package gaiacrtn.swing;

import gaiacrtn.config.ResourceApp;

import javax.swing.*;
import java.util.MissingResourceException;

public class MenuInfo {
   static final int MENU_MENU = 1;
   static final int MENU_POPUP = 2;

   public String strMenuName;
   /** Menu label. May be \c null if the menu is a popup menu and is not
    * defined in the property (popup menu without title!).
    */
   public String strLabel;
   public Icon iconMenu;

   public MenuInfo( String strName, int nMenuType ) {
      strMenuName = strName;
      String strMenuPrefix = "menu." + strMenuName;
      try {
         strLabel = ResourceApp.res.getString( strMenuPrefix + "_menu" );
      } catch (MissingResourceException e) {
         if ( nMenuType == MENU_MENU ) // not required for popup menu.
         {
            strLabel = strName;
            System.err.println( "Missing resource: " + strMenuPrefix + "_menu" );
         } else
            strLabel = null;
      }

      try {
         String strIconFilename =
               ResourceApp.res.getString( strMenuPrefix + "_icon" );
         if ( strIconFilename != null ) {
            iconMenu = new ImageIcon( ResourceApp.appFilename( strIconFilename ) );
         }
      } catch (MissingResourceException e) {
      }
   }
}
