/**
 * Title:        Diff Word<p>
 * Description:  A diff that is not line based but word based.<p>
 * Copyright:    Copyright (c) Baptiste Lepilleur<p>
 * Company:      Gaia Creation<p>
 * @author Baptiste Lepilleur
 * @version 1.0
 */
package gaiacrtn.swing.model;

import gaiacrtn.swing.event.ChangeEventSupport;

import javax.swing.event.ChangeListener;

public class ModelString {
   private String _strText;
   private ChangeEventSupport _changeSupport = new ChangeEventSupport( this );

   public ModelString() {
   }

   public ModelString( String strText ) {
      _strText = strText;
   }

   public String text() {
      return _strText;
   }

   public void setText( String strText ) {
      _strText = strText;
      _changeSupport.fireChange();
   }

   public void addChangeListener( ChangeListener listener ) {
      _changeSupport.addChangeListener( listener );
   }

   public void removeChangeListener( ChangeListener listener ) {
      _changeSupport.removeChangeListener( listener );
   }
}