/**
 * Title:        Diff Word<p>
 * Description:  A diff that is not line based but word based.<p>
 * Copyright:    Copyright (c) Baptiste Lepilleur<p>
 * Company:      Gaia Creation<p>
 * @author Baptiste Lepilleur
 * @version 1.0
 */
package gaiacrtn.swing.text;

import javax.swing.text.BadLocationException;
import javax.swing.text.Document;


/** Helps using class javax.swing.text.document.
 */
public class DocumentHelper {

   public DocumentHelper() {
   }

   /** Gets the text contained in a document.
    * @param doc The text of this document is returned.
    * @return Text of the document.
    */
   static public String getText( Document doc ) {
      String strText;

      try {
         strText = doc.getText( 0, doc.getLength() );
      } catch (BadLocationException e) {
         strText = "";
      }

      return strText;
   }

   /** Sets the text of a document.
    * @param doc The text of this document is replaced.
    * @param strText New text for the document.
    */
   static public void setText( Document doc, String strText ) {
      try {
         doc.remove( 0, doc.getLength() );
         doc.insertString( 0, strText, null );
      } catch (BadLocationException e) {
      }
   }
}