package gaiacrtn.util;

import java.util.Collection;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;


public class CollectionManip {
   /*! Adds all the object of the specified array to the specified collection.
    * @param collection Collection the object are added to.
    * @param objects Array of objects to add.
    */
   public static void addArray( Collection collection, Object[] objects ) {
      if ( collection != null && objects != null ) {
         for (int nIdx = 0; nIdx < objects.length; ++nIdx)
            collection.add( objects[nIdx] );
      }
   }

   /*! Returns a string for the specified collection.
    * @param collection Collection to dump.
    */
   public static String makeString( Collection collection ) {
      StringBuffer str = new StringBuffer(
            "Collection dump: (" + collection.size() + ") objects; " +
            ( collection.getClass() ) + "\n" );
      int nPos = 0;
      for (Iterator it = collection.iterator(); it.hasNext(); ++nPos) {
         Object obj = it.next();
         str.append( nPos );
         str.append( ": \"" );
         str.append( obj );
         str.append( "\"\n" );
      }
      return str.toString();
   }

   /*! Returns a string for the specified collection.
    * @param collection Collection to dump.
    */
   public static String makeString( Map map ) {
      StringBuffer str = new StringBuffer(
            "Map dump: (" + map.size() + ") objects; " +
            ( map.getClass() ) + "\n" );
      Set setEntry = map.entrySet();
      for (Iterator it = setEntry.iterator(); it.hasNext();) {
         Map.Entry entry = (Map.Entry) it.next();
         str.append( entry.getKey() + " <=> " + entry.getValue() );
         str.append( "\n" );
      }
      return str.toString();
   }

   /*! Returns a string for the specified collection.
    * @param collection Collection to dump.
    */
   public static String makePackedString( Collection collection ) {
      StringBuffer str = new StringBuffer( "{#" + collection.size() + ":" );
      for (Iterator it = collection.iterator(); it.hasNext();) {
         Object obj = it.next();
         str.append( obj + ";" );
      }
      str.append( " }" );
      return str.toString();
   }

   /*! Returns a string for the specified collection.
    * @param collection Collection to dump.
    */
   public static String makePackedString( Map map ) {
      StringBuffer str = new StringBuffer( "{#" + map.size() + ":" );
      Set setEntry = map.entrySet();
      for (Iterator it = setEntry.iterator(); it.hasNext();) {
         Map.Entry entry = (Map.Entry) it.next();
         str.append( "(" + entry.getKey() + "<=>" + entry.getValue() + ");" );
      }
      return str.toString();
   }
}