package gaiacrtn.util.diff;

import gaiacrtn.util.diff.Diff;
import gaiacrtn.util.diff.DiffProcessor;

/**
 * Created by IntelliJ IDEA.
 * User: Ice Breaker
 * Date: 20 fvr. 2003
 * Time: 21:43:53
 * To change this template use Options | File Templates.
 */
public class DiffWrapper {
   private Diff.change _diffResult;
   private int _originalListLength;

   public DiffWrapper( Object[] original, Object[] modified ) {
      Diff diffComputer = new Diff( original, modified );
      _diffResult = diffComputer.diff_2( false );
      _originalListLength = original.length;
   }

   public void processResult( DiffProcessor diffProcessor ) {
      int lastOriginalItemUsedIndex = 0;

      for (Diff.change currentChange = _diffResult; currentChange != null; currentChange = currentChange.link) {
         emitChanges( currentChange.line0 - lastOriginalItemUsedIndex, DiffProcessor.UNMODIFIED, diffProcessor );

         lastOriginalItemUsedIndex = currentChange.line0 + currentChange.deleted;

         if ( currentChange.deleted > 0 )
            emitChanges( currentChange.deleted, DiffProcessor.DELETED, diffProcessor );

         if ( currentChange.inserted > 0 )
            emitChanges( currentChange.inserted, DiffProcessor.INSERTED, diffProcessor );
      }

//      if ( lastOriginalItemUsedIndex <= _originalListLength )
//         emitChanges( _originalListLength - lastOriginalItemUsedIndex, DiffProcessor.UNMODIFIED, diffProcessor );
   }

   private void emitChanges( int count, int changeType, DiffProcessor diffProcessor ) {
      while (count-- > 0)
         diffProcessor.processChange( changeType );
   }
}
